Imports System
Imports System.Text
Imports System.IO
Imports System.Collections.Generic

Imports YsTxWLIB

Namespace wlibsamp

    '' //////////////////////////////////////////////////////////
    '' <summary>MainProc　クラス</summary>
    '' //////////////////////////////////////////////////////////
    Public Class MainProc

        Private Shared argSrcfile As String      '//ソースファイル名
        Private Shared argDstfile As String      '//ディストファイル名
        Private Shared argOutfile As String      '//出力ファイル名
        Private Shared argOutFmt As String      '//出力書式モード
        Private Shared argCsvFmt As String      '//出力ＣＳＶ書式モード

        '' ==================================================================
        '' <summary>
        '' 差分出力処理メイン 
        '' </summary>
        '' <param name="args">コマンド引数</param>
        '' <returns> 0=正常　0!= 異常</returns>
        '' <remarks>
        '' 差分出力処理メイン 
        '' <7/remarks>
        '' ==================================================================
        Public Shared Function Proc(ByVal args() As String) As Integer

            Dim iRet As Integer
            ''=======================================
            ''  引数チェック         
            ''=======================================
            If args.Length < 5 Then

                Console.WriteLine("コマンド: ファイルの差分を出力する")
                Console.WriteLine("形式: %s  wlibsamp_diff srcfile dstfile outfile")
                Console.WriteLine("引数: 1  srcfile    ソースファイル名")
                Console.WriteLine("      2  dstfile    ディストファイル名")
                Console.WriteLine("      3  outfile    出力ファイル名")
                Console.WriteLine("      4  dfmt       出力書式モード")
                Console.WriteLine("      5  csvfmt     出力ＣＳＶ書式モード")
                Return (-1)
            End If

            argSrcfile = args(0)   '//ソースファイル名
            argDstfile = args(1)   '//ディストファイル名
            argOutfile = args(2)   '//出力ファイル名
            argOutFmt = args(3)    '// 出力書式モード
            argCsvFmt = args(4)    '// 出力ＣＳＶ書式モード

            ''=======================================
            ''  初期化         
            ''=======================================

            ''=======================================
            ''  開始処理         
            ''=======================================
            Dim mkDate As DateTime = DateTime.Now '現在時刻
            Console.WriteLine(" ==========================================================")
            Console.WriteLine("*** wlibsamp 開始 " & mkDate)
            Console.WriteLine(" ==========================================================")

            ''=======================================
            ''  引数確認         
            ''=======================================
            Console.WriteLine("引数1 ソースファイル名   = " & args(0))
            Console.WriteLine("引数2 ディストファイル名 = " & args(1))
            Console.WriteLine("引数3 出力ファイル名     = " & args(2))
            Console.WriteLine("引数4 出力書式モード     = " & args(3))
            Console.WriteLine("引数5 出力ＣＳＶ書式モード     = " & args(4))

            ''=======================================
            ''  本処理         
            ''=======================================
            Dim srcflAry As List(Of String) = New List(Of String) ' ソースファイル読み込み領域
            Dim dstflAry As List(Of String) = New List(Of String) ' ディストファイル読み込み領域

            Dim txtFile1 As String = argSrcfile '
            Dim txtFile2 As String = argDstfile '

            '' テキスト差分オブジェクト生成・オープン
            Dim txdf as YsTxWDiff = new YsTxWDiff()
            txdf.Init()
            txdf.Open(YsTxWDiff.DefDifDif)
            
            ''ファイルを文字列に読み込む
            iRet = txdf.ReadFile(txtFile1, srcflAry)
            iRet = txdf.ReadFile(txtFile2, dstflAry)

            Dim dfList1 As List(Of diffStct) = New List(Of diffStct)
            Dim fmtList as List(Of String) =  New List(Of String)

            ''差分比較
            dfList1 = txdf.MakeDiffStr(srcflAry, dstflAry)

            ''文字列を書式化する
            Dim outfmt As Integer = integer.Parse (argOutFmt)
            Dim csvfmt As Integer = integer.Parse (argCsvFmt)
            fmtList = txdf.FmtDiffList(outfmt, csvfmt, dfList1)

            ''ファイルに書き出す
            txdf.WriteFile(argOutfile, fmtList)

            Console.WriteLine("変更無し行 = " & txdf.DifNorLine)
            Console.WriteLine("追加行 = " & txdf.DifAddLine)
            Console.WriteLine("削除行 = " & txdf.DifDelLine)
            Console.WriteLine("変更行 = " & txdf.DifChgLine)

            '' テキスト差分オブジェクトクローズ
            txdf.Close()

            ''=======================================
            ''  終了         
            ''=======================================
            mkDate = DateTime.Now '現在時刻
            Console.WriteLine(" ==========================================================")
            Console.WriteLine("*** wlibsamp 終了 " & mkDate)
            Console.WriteLine(" ==========================================================")

            return(0)

        End Function

    End Class

    '' //////////////////////////////////////////////////////////
    '' <summary>wlibsamp　クラス</summary>
    '' //////////////////////////////////////////////////////////
    Public Class wlibsamp

        '' ==================================================================
        '' <summary>
        '' メイン関数 
        '' </summary>
        '' <param name="args">コマンド引数</param>
        '' <returns> 0=正常　0!= 異常</returns>
        '' <remarks>
        '' メイン関数処理 
        '' </remarks>
        '' ==================================================================
        Public Shared Sub Main(ByVal args() As String)
            Dim iRet As Integer

            iRet = MainProc.Proc(args)
        End Sub 'Main

    End Class

End Namespace
